require "defines"

local timer, char, drain
local ontick = defines.events.on_tick
local stamstat = {}

function init()
	timer = game.tick % 3
	for name,e in pairs(game.entity_prototypes) do
		if e.type == "player" then
			stamstat[name]= {
				["critical"] = e.max_health/8,
				["full"] = e.max_health,
				["walkdrain"] = e.healing_per_tick * 1.5,
				["regenoffset"] = e.healing_per_tick * 3,
			}
		end
	end
end

-- -1=logged out, 1 = logged in

function stamina(event)
	if timer < 2 then timer = timer + 1 return end
	timer = 0
	
	for _,p in pairs(game.players) do
		if p.connected then char = p.character else char = nil end
		if char then
			local stat = stamstat[char.name]
		
			drain = 0
			if p.crafting_queue_size > 0 then drain = drain + 1 end
			if p.mining_state.mining then drain = drain + 1 end
			if drain > 0 then
				drain = drain/20 + stat.regenoffset
				if char.health < stat.critical then
					if char.health < drain then
						char.die()
					else
						char.health = char.health - (drain-.001)
						char.damage(.001,p.force)
					end
				else
					char.health = char.health - drain
				end
			elseif p.walking_state.walking and char.health<stat.full then
				char.health = char.health - stat.walkdrain
			end
		end
	end

end

script.on_event(ontick,function(event)
	init()
	stamina(event)
	script.on_event(ontick,stamina)
end)
